%define anolis_release 1

Name: ModemManager
Version: 1.22.0
Release: %{anolis_release}%{?dist}
Summary: Mobile broadband modem management service
License: GPL-2.0+
URL: http://www.freedesktop.org/wiki/Software/ModemManager/
Source0: https://gitlab.com/linux-mobile-broadband/ModemManager/-/archive/%{version}/%{name}-%{version}.tar.bz2

# All of these are applied upstream. Can drop on rebase to 1.24
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/7dfd59157e80bb2b761c926d3a295254e05441d2
Patch0: 0001-shared-qmi-do-not-leak-a-string-in-error-path.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/39a90fc39a2e723dea7e6895ace9c9b157b2a3a1
Patch1: 0001-ublox-helpers-fix-propagation-of-URAT-response-parse.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/5f6b09536036655e46dd2669f2e141f10e1c1088
Patch2: 0003-broadband-modem-fix-a-potential-leak-in-cusd_process.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/a42d12f660074304d6497b0323a2052086a6e942
Patch3: 0004-shared-qmi-fix-a-leak-in-error-handling-path.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/5cdeea43dab0576dbd92ce53aba31c4afcc59db8
Patch4: 0005-quectel-shared-do-not-leak-name-string.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/50937f52532a44660df310c075c86130178bf0da
Patch5: 0006-port-qmi-fix-array-bound-check.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/6ca02a3edf3cfa2ddfbc78b72da23d81d5995bba
Patch6: 0007-mmcli-sms-do-not-leak-message_reference.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/90824b3e87806d55057ed713e4eb694edf3e685a
Patch7: 0008-bearer-qmi-fix-a-copy-n-paste-error.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/000acf4922240ea3f88e9b9ace5996c18fbe8aec
Patch8: 0009-sim-qmi-do-not-leak-access-technology-name.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/bd0551460bc7591329fc17dbec4e160a4a35e812
Patch9: 0010-libmm-glib-signal-fix-a-copy-n-paste-error.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/df8287bf6c2febd068d06f0f45194bc622118bd4
Patch10: 0011-modem-helpers-do-not-leak-past-PDP-on-error.patch
# https://gitlab.com/linux-mobile-broadband/ModemManager/-/commit/509acb647462c5bd5c4b782076cb46a60dff9f07
Patch11: 0001-mmcli-fix-a-memory-leak.patch

# For mbim-proxy and qmi-proxy
Requires: libmbim-utils
Requires: libqmi-utils
Requires: %{name}-glib = %{version}-%{release}

Requires(post): systemd
Requires(postun): systemd
Requires(preun): systemd

Requires: polkit

BuildRequires: meson >= 0.53
BuildRequires: dbus-devel
BuildRequires: dbus-daemon
BuildRequires: pkgconfig(gio-2.0)
BuildRequires: pkgconfig(gio-unix-2.0)
BuildRequires: pkgconfig(glib-2.0) >= 2.56.0
BuildRequires: pkgconfig(gmodule-2.0)
BuildRequires: pkgconfig(gobject-2.0)
BuildRequires: pkgconfig(gudev-1.0) >= 232
BuildRequires: pkgconfig(libsystemd) >= 209
BuildRequires: pkgconfig(mbim-glib) >= 1.26.0
BuildRequires: pkgconfig(polkit-gobject-1) >= 0.97
BuildRequires: pkgconfig(qmi-glib) >= 1.30.8
BuildRequires: pkgconfig(qrtr-glib) >= 1.0.0
BuildRequires: pkgconfig(systemd)
BuildRequires: gettext-devel >= 0.19.8
BuildRequires: gobject-introspection-devel >= 0.9.6
BuildRequires: gtk-doc
BuildRequires: systemd
BuildRequires: vala
BuildRequires: python3-gobject
BuildRequires: python3-dbus

%global __provides_exclude ^libmm-plugin-

%description
The ModemManager service manages WWAN modems and provides a consistent API for
interacting with these devices to client applications.

%package devel
Summary: Libraries and headers for adding ModemManager support to applications
Requires: %{name} = %{version}-%{release}

%description devel
This package contains various headers for accessing some ModemManager functionality
from applications.

%package glib
Summary: Libraries for adding ModemManager support to applications that use glib.

%description glib
This package contains the libraries that make it easier to use some ModemManager
functionality from applications that use glib.

%package glib-devel
Summary: Libraries and headers for adding ModemManager support to applications that use glib.
Requires: %{name} = %{version}-%{release}
Requires: %{name}-devel = %{version}-%{release}
Requires: %{name}-glib = %{version}-%{release}

%description glib-devel
This package contains various headers for accessing some ModemManager functionality
from glib applications.

%package vala
Summary: Vala bindings for ModemManager
Requires: vala
Requires: %{name}-glib = %{version}-%{release}

%description vala
Vala bindings for ModemManager

%prep
%autosetup -p1

%build
# Let's avoid BuildRequiring bash-completion because it changes behavior
# of shell, at least until the .pc file gets into the -devel subpackage.
# We'll just install the bash-completion file ourselves.
%meson \
	-Ddist_version='"%{version}-%{release}"' \
	-Dudevdir=/usr/lib/udev \
	-Dsystemdsystemunitdir=%{_unitdir} \
	-Dvapi=true \
	-Dgtk_doc=true \
	-Dpolkit=permissive \
	-Dbash_completion=false
%meson_build


%install
%meson_install
find %{buildroot}%{_datadir}/gtk-doc |xargs touch --reference meson.build
%find_lang %{name}
mkdir -p %{buildroot}%{_datadir}/bash-completion/completions/
cp -a cli/mmcli-completion %{buildroot}%{_datadir}/bash-completion/completions/mmcli


%check
# meson_test

%post
%systemd_post ModemManager.service

%preun
%systemd_preun ModemManager.service

%postun
%systemd_postun ModemManager.service

%files -f %{name}.lang
%license COPYING
%doc README
%{_sysconfdir}/dbus-1/system.d/org.freedesktop.ModemManager1.conf
%{_datadir}/dbus-1/system-services/org.freedesktop.ModemManager1.service
%attr(0755,root,root) %{_sbindir}/ModemManager
%attr(0755,root,root) %{_bindir}/mmcli
%dir %{_libdir}/%{name}
%attr(0755,root,root) %{_libdir}/%{name}/*.so*
%{_udevrulesdir}/*
%{_datadir}/polkit-1/actions/*.policy
%{_unitdir}/ModemManager.service
%{_datadir}/icons/hicolor/22x22/apps/*.png
%{_datadir}/bash-completion
%{_datadir}/ModemManager
%{_mandir}/man1/*
%{_mandir}/man8/*

%files devel
%{_includedir}/ModemManager/
%dir %{_datadir}/gtk-doc/html/%{name}
%{_datadir}/gtk-doc/html/%{name}/*
%{_libdir}/pkgconfig/%{name}.pc
%{_datadir}/dbus-1/interfaces/*.xml

%files glib
%license COPYING
%{_libdir}/libmm-glib.so.*
%{_libdir}/girepository-1.0/*.typelib

%files glib-devel
%{_libdir}/libmm-glib.so
%dir %{_includedir}/libmm-glib
%{_includedir}/libmm-glib/*.h
%{_libdir}/pkgconfig/mm-glib.pc
%dir %{_datadir}/gtk-doc/html/libmm-glib
%{_datadir}/gtk-doc/html/libmm-glib/*
%{_datadir}/gir-1.0/*.gir

%files vala
%{_datadir}/vala/vapi/libmm-glib.*

%changelog
* Fri Feb 14 2025 Zhao Hang <wb-zh951434@alibaba-inc.com> - 1.22.0-1
- Update to 1.22.0-1 from 1.18.12-1
- Switch to build using meson
- Add patches for a couple of bugs that make static analysis unhappy
  [Patches cherry-pick from c10s. Original changelog:
  - Add patches for a couple of bugs that make static analysis unhappy.]

* Sun Jan 15 2023 Funda Wang <fundawang@yeah.net> - 1.18.12-1
- New version 1.18.12

* Mon Mar 14 2022 Yaobin Shi <shiyaobin.syb@alibaba-inc.com> - 1.18.6-2
- Enable make check for Anolis OS 23
- Add BuildRequires python3-gobject and python3-dbus

* Thu Mar 10 2022 Larry Shi <larryshi@openanolis.org> - 1.18.6-1
- Init for Anolis OS 23
